-- by "Marhu" 
-- v 1.0
-- Date: 02.04.2013
-- "KuhZucht Zentral Einheit"
			
KuhZuchtZE = {};

function KuhZuchtZE:loadMap(name)
	
		
	self.MilkFillLevel = 0;
	self.MilkCapacity = 0;
	self.nextKalb = 0;
	self.nextKuh = 9999999999;
	self.updateMs = 0;
	self.updateMin = 0;
	self.KuhZuchtPlace = {};
	
	
	if not self.iniStatPage then
		MissionPDA.addStatsPage(g_currentMission.missionPDA, self.DrawStats,self,"zucht");
		self.iniStatPage = true;
	end;
	
end;

function KuhZuchtZE:deleteMap()
	self.iniStatPage = nil;
	self.Initialize = nil;
	self.KuhZuchtPlace = {};
end;

function KuhZuchtZE:mouseEvent(posX, posY, isDown, isUp, button)
end;

function KuhZuchtZE:keyEvent(unicode, sym, modifier, isDown)
end;

function KuhZuchtZE:update(dt)
	
	if not self.Initialize then
		self:ReadZuchtPlaces();
		self.Initialize = true;
	end
	
	self.updateMs = self.updateMs + (dt * g_currentMission.missionStats.timeScale);
	if self.updateMs >= 60000 then
		
		self:ReadZuchtPlaces();
		
		if self.numKalb < self.MaxKalb then
			
			local cow = g_currentMission.husbandries.cow;
			if self.MilkFillLevel > 0 then
				self.updateMin = self.updateMin + 1;
				
				if cow.productivity > 0 then
					self.nextKalb = math.floor((100 / (cow.totalNumAnimals * cow.productivity)) * 1440) - self.updateMin;
					
					if self.nextKalb <= 0 then
						self.updateMin = 0;
						self:addKalb();
					end;
				end;
			end;
		end;
		self.updateMs = self.updateMs - 60000;
	end;
		
end;

function KuhZuchtZE:draw()
	
end;

local function MinToTimeSring(minute)

	local tt = "";
	local days = math.floor(minute / 1440);
	local hours = math.mod(math.floor(minute / 60), 24);
	if days > 0 then
		tt = tostring(days).." "..g_i18n:getText("Tage");
	elseif hours > 0 then
		tt = tostring(hours).." "..g_i18n:getText("Stunden");
	else
		tt = tostring(math.floor(minute)).." "..g_i18n:getText("Minuten");
	end;
	
	return tt;
end

function KuhZuchtZE:DrawStats(a,b,c,d)

	if a == "zucht" then 
		
		local y = g_currentMission.missionPDA.pdaHeadRow;
		local h = g_currentMission.missionPDA.pdaFontSize;
		local x = g_currentMission.missionPDA.pdaCol1;
		setTextColor(1, 1, 1, 1);
		setTextAlignment(RenderText.ALIGN_LEFT);
		
		setTextBold(true);
		renderText(x, y, h,	string.format(g_i18n:getText("Zuchtanlagen"),table.getn(self.KuhZuchtPlace)));
		setTextBold(false);
		y = y - (g_currentMission.missionPDA.pdaRowSpacing * 2);
				
		local desc = Fillable.fillTypeIndexToDesc[Fillable.FILLTYPE_MILK].nameI18N;
		renderText(x, y, h, string.format("%s",desc.." [l]"));
		x = g_currentMission.missionPDA.pdaCol2;
		renderText(x, y, h, string.format("%d",self.MilkFillLevel));
		y = y - g_currentMission.missionPDA.pdaRowSpacing;
		
		self:ReadZuchtPlaces();
		
		x = g_currentMission.missionPDA.pdaCol1;
		renderText(x, y, h, g_i18n:getText("Kaelber"));
		x = g_currentMission.missionPDA.pdaCol2;
		renderText(x, y, h, string.format("%d/%d",self.numKalb,self.MaxKalb));
		y = y - g_currentMission.missionPDA.pdaRowSpacing;
		
		x = g_currentMission.missionPDA.pdaCol1;
		renderText(x, y, h, g_i18n:getText("nextKalb"));
		x = g_currentMission.missionPDA.pdaCol2;
		if self.nextKalb > 0 then
			renderText(x, y, h, MinToTimeSring(self.nextKalb));
		elseif self.numKalb < self.MaxKalb then
			renderText(x, y, h, g_i18n:getText("WarteUpdate"));	
		else
			renderText(x, y, h, g_i18n:getText("NoPlace"));		
		end 
		y = y - g_currentMission.missionPDA.pdaRowSpacing;
		
		x = g_currentMission.missionPDA.pdaCol1;
		renderText(x, y, h, g_i18n:getText("nextKuh"));
		x = g_currentMission.missionPDA.pdaCol2;
		if self.nextKuh < 9999999999 then
			renderText(x, y, h, MinToTimeSring(self.nextKuh));
		elseif self.numKalb == 0 then
			renderText(x, y, h, g_i18n:getText("NoKalb"));		
		else
			renderText(x, y, h, g_i18n:getText("WarteUpdate"));		
		end
		y = y - g_currentMission.missionPDA.pdaRowSpacing;
		
	end
end

function KuhZuchtZE:ReadZuchtPlaces()
	local numZucht = table.getn(self.KuhZuchtPlace);
	self.MaxKalb = numZucht * 5;
	self.MilkCapacity = numZucht * 6000;
	self.numKalb = 0;
	self.nextKuh = 9999999999;
	for i = 1 , numZucht do
		for j = 1, 5 do
			if self.KuhZuchtPlace[i].Kaelber[j].has then
				self.numKalb = self.numKalb + 1;
				self.nextKuh = math.min(self.nextKuh,self.KuhZuchtPlace[i].Kaelber[j].t);
			end;
		end;
	end;
	
end;

function KuhZuchtZE:addKalb()
	if g_server ~= nil  then
		local numZucht = table.getn(self.KuhZuchtPlace);
		
		for i = 1 , numZucht do
			local numKalb = 0;
			for j = 1, 5 do
				if self.KuhZuchtPlace[i].Kaelber[j].has then
					numKalb = numKalb + 1;
				end
			end
			if numKalb < 5 then
				self.KuhZuchtPlace[i]:addKalb();
				break;
			end;
		end;
	end;
end;

function KuhZuchtZE:setFillLevel(fillLevel, UpdateCapa)
	
	if UpdateCapa then
		self.MilkCapacity = table.getn(self.KuhZuchtPlace) * 6000;
	end	
	if fillLevel > self.MilkCapacity then
		fillLevel = self.MilkCapacity;
	end;
	if fillLevel < 0 then
		fillLevel = 0;
	end;
	self.MilkFillLevel = fillLevel;

end;

function KuhZuchtZE:getFillLevel()
	
	return self.MilkFillLevel;

end

addModEventListener(KuhZuchtZE);